/****************************************************************************************
 * LiveZilla ChatStartpageClass.js
 *
 * Copyright 2014 LiveZilla GmbH
 * All rights reserved.
 * LiveZilla is a registered trademark.
 *
 ***************************************************************************************/
function ChatStartpageClass() {

}

ChatStartpageClass.prototype.createStartPage = function(lz, ca, cr) {
    var i = 0, hashArray = [], singleStartpageIframe;
    var numberOfStartPages = (lzm_chatDisplay.startPages.show_lz == '1') ? 1 : 0;
    numberOfStartPages += lzm_chatDisplay.startPages.others.length;
    if (!lzm_chatDisplay.startPageTabControlDoesExist) {
        $('#startpage-headline').html('<h3>' + t('Startpage') + '</h3>');
        if (numberOfStartPages == 1) {
            singleStartpageIframe = this.createSingleStartPage(lz, ca, cr);
            if (singleStartpageIframe != '')
                $('#startpage-body').html(singleStartpageIframe);
            lzm_chatDisplay.startPageTabControlDoesExist = false;
        } else {
            $('#startpage-body').html('<div id="startpage-placeholder" style="margin-top: 5px;"></div>');
            lzm_displayHelper.createTabControl('startpage-placeholder', this.createStartPagesArray(lz, ca, cr), -1);
            lzm_chatDisplay.startPageTabControlDoesExist = true;
        }
    } else {
        if (numberOfStartPages == 1) {
            singleStartpageIframe = this.createSingleStartPage(lz, ca, cr);
            if (singleStartpageIframe != '')
                $('#startpage-body').html(singleStartpageIframe);
            lzm_chatDisplay.startPageTabControlDoesExist = false;
        } else {
            lzm_displayHelper.updateTabControl('startpage-placeholder', this.createStartPagesArray(lz, ca, cr));
            lzm_chatDisplay.startPageTabControlDoesExist = true;
        }
    }
    lzm_displayLayout.resizeStartPage();
};

ChatStartpageClass.prototype.createSingleStartPage = function(lz, ca, cr) {
    var startPageHtml = '';
    if (lz ||ca.length > 0 || cr.length) {
        if (lzm_chatDisplay.startPages.show_lz == '1') {
            var pcx0 = 14, pcx1 = -1;
            if (lzm_chatServerEvaluation.crc3 != null) {
                try {
                    pcx0 = Math.max(0, 1209600 - Math.ceil(lzm_chatTimeStamp.getServerTimeString(null, true) - parseInt(lzm_chatServerEvaluation.crc3[0])));
                    pcx1 = lzm_chatServerEvaluation.crc3[5];
                } catch(e) {}
            }
            var pcx = pcx0 + '_' + pcx1;
            var startPageUrl = 'https://start.livezilla.net/startpage/en/?&product_version=' + lzm_commonConfig.lz_version +
                '&web=1&app=' + app + '&mobile=' + mobile + '&pcx=' + pcx;
            startPageHtml = '<iframe id="single-startpage-iframe" src="' + startPageUrl + '" style="border:0px;"></iframe>';
        } else {
            var customPageUrl = lzm_chatDisplay.startPages.others[0].url;
            if (lzm_chatDisplay.startPages.others[0].get_param != 0) {
                customPageUrl += (customPageUrl.indexOf('?') != -1) ? '&' : '?';
                customPageUrl += 'operator=' + lzm_chatServerEvaluation.myUserId;
            }
            startPageHtml = '<iframe id="single-startpage-iframe" src="' + customPageUrl + '" style="border:0px;"></iframe>';
        }
    }
    return startPageHtml
};

ChatStartpageClass.prototype.createStartPagesArray = function(lz, ca, cr) {
    var startPagesArray = [], i = 0, customPageUrl;
    var pcx0 = 14, pcx1 = -1;
    if (lzm_chatServerEvaluation.crc3 != null) {
        try {
            pcx0 = Math.max(0, 1209600 - Math.ceil(lzm_chatTimeStamp.getServerTimeString(null, true) - parseInt(lzm_chatServerEvaluation.crc3[0])));
            pcx1 = lzm_chatServerEvaluation.crc3[5];
        } catch(e) {}
    }
    var pcx = pcx0 + '_' + pcx1;
    var startPageUrl = 'https://start.livezilla.net/startpage/en/?&product_version=' + lzm_commonConfig.lz_version +
        '&web=1&app=' + app + '&mobile=' + mobile + '&pcx=' + pcx;
    if (!lzm_chatDisplay.startPageTabControlDoesExist) {
        if (lzm_chatDisplay.startPages.show_lz == 1) {
            startPagesArray.push({name: t('Startpage'), content: '<iframe id="startpage-lz" class="startpage-iframe"' +
                ' src="' + startPageUrl + '"></iframe>', hash: 'lz'});
        }
        for (i=0; i<lzm_chatDisplay.startPages.others.length; i++) {
            customPageUrl = lzm_chatDisplay.startPages.others[i].url;
            if (lzm_chatDisplay.startPages.others[i].get_param != 0) {
                customPageUrl += (customPageUrl.indexOf('?') != -1) ? '&' : '?';
                customPageUrl += 'operator=' + lzm_chatServerEvaluation.myUserId;
            }
            startPagesArray.push({name: lzm_chatDisplay.startPages.others[i].title, content: '<iframe id="startpage-' +
                lzm_chatDisplay.startPages.others[i].hash + '" class="startpage-iframe" src="' + customPageUrl + '"></iframe>',
                hash: lzm_chatDisplay.startPages.others[i].hash});
        }
    } else {
        if (lz && lzm_chatDisplay.startPages.show_lz == 1) {
            startPagesArray.push({name: t('Startpage'), content: '<iframe id="startpage-lz" class="startpage-iframe"' +
                ' src="' + startPageUrl + '"></iframe>', hash: 'lz', action: lzm_chatDisplay.startPages.show_lz});
        }
        for (i=0; i<ca.length; i++) {
            customPageUrl = ca[i].url;
            if (ca[i].get_param != 0) {
                customPageUrl += (customPageUrl.indexOf('?') != -1) ? '&' : '?';
                customPageUrl += 'operator=' + lzm_chatServerEvaluation.myUserId;
            }
            startPagesArray.push({name: ca[i].title, content: '<iframe id="startpage-' + ca[i].hash +
                '" class="startpage-iframe" src="' + customPageUrl + '"></iframe>', hash: ca[i].hash, action: 1});
        }
        for (i=0; i<cr.length; i++) {
            startPagesArray.push({name: cr[i].title, content: '', hash: cr[i].hash, action: 0});
        }
    }
    return startPagesArray;
};
