/****************************************************************************************
 * LiveZilla CommonTranslationClass.js
 *
 * Copyright 2013 LiveZilla GmbH
 * All rights reserved.
 * LiveZilla is a registered trademark.
 *
 ***************************************************************************************/

/**
 *
 * @constructor
 */
function CommonTranslationClass(protocol, url, mobileDir, runningFromApp, language) {
    this.translationArray = [];
    this.manageTranslationArray = [];
    this.protocol = protocol;
    this.url = url;
    this.mobileDir = mobileDir;
    this.availableLanguages = [];
    this.language = 'en';
    if (typeof language != 'undefined' && language != 'undefined' && language != '') {
        this.language = language
    } else if (typeof navigator.language != 'undefined') {
        this.language = navigator.language;
    } else if (typeof navigator.userLanguage != 'undefined') {
        this.language = navigator.userLanguage;
    }
    if (this.language.indexOf('-') != -1) {
        this.language = this.language.split('-')[0] + '-' + this.language.split('-')[1].toLowerCase();
    } else if (this.language.indexOf('_') != -1) {
        this.language = this.language.split('_')[0] + '-' + this.language.split('_')[1].toLowerCase();
    }
}

CommonTranslationClass.prototype.translate = function(translateString, placeholderArray) {
    var translatedString = translateString;
    var notInArray = true;
    for (var stringIndex=0; stringIndex<this.translationArray.length; stringIndex++) {
        if (this.translationArray[stringIndex]['orig'] == translateString) {
            if (this.translationArray[stringIndex][this.language] != null)
                translatedString =  this.translationArray[stringIndex][this.language];
            notInArray = false;
            break;
        }
    }

    if (typeof placeholderArray != 'undefined') {
        for (var i=0; i<placeholderArray.length; i++) {
            translatedString = this.stringReplace(translatedString, placeholderArray[i][0], placeholderArray[i][1]);
        }
    }

    return translatedString;
};

CommonTranslationClass.prototype.stringReplace = function(myString, placeholder, replacement) {
    return myString.replace(placeholder, replacement);
} ;

CommonTranslationClass.prototype.setTranslationData = function(translationData) {
    this.translationArray = translationData;
};
